zoukankan      html  css  js  c++  java
  • Lightoj 1017

    1017 - Brush (III)
    Time Limit: 2 second(s) Memory Limit: 32 MB

    Samir returned home from the contest and got angry after seeing his room dusty. Who likes to see a dusty room after a brain storming programming contest? After checking a bit he found a brush in his room which has width w. Dusts are defined as 2D points. And since they are scattered everywhere, Samir is a bit confused what to do. He asked Samee and found his idea. So, he attached a rope with the brush such that it can be moved horizontally (in X axis) with the help of the rope but in straight line. He places it anywhere and moves it. For example, the y co-ordinate of the bottom part of the brush is 2 and its width is 3, so the y coordinate of the upper side of the brush will be 5. And if the brush is moved, all dusts whose y co-ordinates are between 2 and 5 (inclusive) will be cleaned. After cleaning all the dusts in that part, Samir places the brush in another place and uses the same procedure. He defined a move as placing the brush in a place and cleaning all the dusts in the horizontal zone of the brush.

    You can assume that the rope is sufficiently large. Since Samir is too lazy, he doesn't want to clean all the room. Instead of doing it he thought that he would use at most k moves. Now he wants to find the maximum number of dust units he can clean using at most k moves. Please help him.

    Input

    Input starts with an integer T (≤ 100), denoting the number of test cases.

    Each case starts with a blank line. The next line contains three integers N (1 ≤ N ≤ 100), w (1 ≤ w ≤ 10000) and k (1 ≤ k ≤ 100)N means that there are N dust points. Each of the next N lines contains two integers: xi yi denoting the coordinates of the dusts. You can assume that (-109 ≤ xi, yi ≤ 109) and all points are distinct.

    Output

    For each case print the case number and the maximum number of dusts Samir can clean using at most k moves.

    Sample Input

    Output for Sample Input

    2

    3 2 1

    0 0

    20 2

    30 2

    3 1 1

    0 0

    20 2

    30 2

    Case 1: 3

    Case 2: 2

    dp

    状态转移方程: dp[i][j]=max(dp[i-1][j],dp[i-a[i]][j-1]+a[i]);

    /* ***********************************************
    Author        :guanjun
    Created Time  :2016/6/20 20:26:19
    File Name     :1017.cpp
    ************************************************ */
    #include <iostream>
    #include <cstring>
    #include <cstdlib>
    #include <stdio.h>
    #include <algorithm>
    #include <vector>
    #include <queue>
    #include <set>
    #include <map>
    #include <string>
    #include <math.h>
    #include <stdlib.h>
    #include <iomanip>
    #include <list>
    #include <deque>
    #include <stack>
    #define ull unsigned long long
    #define ll long long
    #define mod 90001
    #define INF 0x3f3f3f3f
    #define maxn 10010
    #define cle(a) memset(a,0,sizeof(a))
    const ull inf = 1LL << 61;
    const double eps=1e-5;
    using namespace std;
    priority_queue<int,vector<int>,greater<int> >pq;
    struct Node{
        int x,y;
    };
    struct cmp{
        bool operator()(Node a,Node b){
            if(a.x==b.x) return a.y> b.y;
            return a.x>b.x;
        }
    };
    
    bool cmp(int a,int b){
        return a>b;
    }
    ll y[maxn];
    map<int ,int >mp;
    int main()
    {
        #ifndef ONLINE_JUDGE
        freopen("in.txt","r",stdin);
        #endif
        //freopen("out.txt","w",stdout);
        int T,n,w,k;
        ll x;
        cin>>T;
        for(int t=1;t<=T;t++){
            cin>>n>>w>>k;
            for(int i=1;i<=n;i++){
                cin>>x>>y[i];
            }
            sort(y+1,y+1+n);
            int a[1010]={0};
            int num=1;
            for(int i=1;i<=n;i++){
                x=y[i];
                for(int j=i;j>=1;j--){
                    if(x-y[j]>w)break;
                    a[i]++;
                }
            }
            //a[i]表示在i处刷一下 能覆盖前面多少点
            int dp[110][110]={0};//前 i个数选 j次能得到的最大值
            for(int i=1;i<=n;i++){
                for(int j=1;j<=k;j++){
                    dp[i][j]=max(dp[i-1][j],dp[i-a[i]][j-1]+a[i]);
                }
            }
            printf("Case %d: %d
    ",t,dp[n][k]);
        }
        return 0;
    }
  • 相关阅读:
    C#中的异常处理
    How to: Create a Windows Communication Foundation Client
    王立平--result += &quot;{&quot;;
    Gradle增量学习建筑
    android 当屏幕截图,你如何改变屏幕内容,他们俩bitmap将合并的图像被一起显示
    惊人go语言(image网站开发)
    树莓派的演奏音符3 -- LCD1602显示文章
    Linux解析内核源代码——传输控制块诞生
    Preemption Context Switches 和 Synchronization Context Switches
    folat i = 0.1; 警告
  • 原文地址:https://www.cnblogs.com/pk28/p/5601898.html
Copyright © 2011-2022 走看看